#include<sep_params.h>
#include<sregf.h>
#include <seplib.h>
#include <vel_fd_3d.h>
#include <data_rtm_3d.h>
#include <image_rtm_3d.h>
#include "source_func_3d.h"
#include "rtm_zero_op_3d.h"
#include "gpu_funcs_3d.h"

 main(int argc, char **argv){

   sep_params pars=sep_params(argc,argv);
   data_rtm_3d data=data_rtm_3d("data",&pars);

   source_func wavelet=source_func("wavelet"); 
   axis asx=data.get_axis(4);
   axis asy=data.get_axis(5);

   float src_depth=pars.get_float("src_depth",0.);
   wavelet.set_sources_3d(src_depth,asx,asy);
   vel_fd_3d vel=vel_fd_3d("velocity");

   image_rtm_3d image=image_rtm_3d("image",&vel);
   image.set_source_file(&image);

   oc_float *d2=new oc_float("dataout",&data);
   data.set_source_file(d2);

   int dev=pars.get_int("device",0);
   setup_cuda(dev,argc,argv);

   float aper=pars.get_float("aper",8.);
   int *rand_vec=0;

   rtm_zero_op op=rtm_zero_op(&pars,&vel,&wavelet,&data,0,&image,aper,true,false,rand_vec,false,false);

   op.forward(false,&image,d2,1);

   return 0;
 }






