#include<sep_params.h>
#include<sregf.h>
#include <seplib.h>
#include <vel_fd_3d.h>
#include <data_rtm_3d.h>
#include <image_rtm_3d.h>
#include "source_func_3d.h"
#include "rtm_zero_op_3d.h"
#include "gpu_funcs_3d.h"
#include "cgstep.h"
#include "lin_solver.h"

 main(int argc, char **argv){
 
   sep_params pars=sep_params(argc,argv);
   data_rtm_3d data=data_rtm_3d("data",&pars);
   data_rtm_3d bdata=data_rtm_3d("bdata",&pars);
   source_func wavelet=source_func("wavelet"); 

   axis asx=data.get_axis(4);
   axis asy=data.get_axis(5);

   int niter=pars.get_int("niter",5);
   float src_depth=pars.get_float("src_depth",0.);

   wavelet.set_sources_3d(src_depth,asx,asy);
   vel_fd_3d vel=vel_fd_3d("velocity");
   image_rtm_3d image=image_rtm_3d("image",&vel);

   image.zero();

   image.set_source_file(&image);

   //This defines our original, unencoded data
   oc_float *d1=new oc_float("main_data2.H",&data);
   data.set_source_file(d1);

   //This defines our data encoded into a single shot
   oc_float *d2=new oc_float("enc_data2.H",&bdata);
   bdata.set_source_file(d2);

   int dev=pars.get_int("device",0);
   setup_cuda(dev,argc,argv);
   float aper=pars.get_float("aper",8.);

   int *rand_vec=new int[data.get_axis(4).n*data.get_axis(5).n];

   rtm_zero_op op=rtm_zero_op(&pars,&vel,&wavelet,&data,&bdata,&image,aper,true,true,rand_vec,false,true);

   cgstep *st=new cgstep();

   //Lin_solver contains this solver
   simple_solver *solv=new simple_solver(st,&bdata,&op/*,&tm*/);

   solv->set_verbose(3);
   solv->solve(niter);

   oc_float *mine=(oc_float*) solv->return_model();
   image.tagit="image";
   image.add(mine);

   return 0;
 }






