#include "cutil_inline.h"
#include "cutil_math.h"
#include "gpu_finite_3d.h"
#include <stdlib.h>
#include "sep3d.h"
#include "seplib.h"  
#include "cudaErrors.cu"
#include "wave_fkernel.3d8o.cu"
//#include "wave_fkernel.3d14o.cu"
//Simply uncomment to use 14th order propagation, remember to redefine the 'fat' size in fd_prop_3d

double dd1,dd2,dd3;

extern "C" __global__ void new_src_inject_kernel(int it, int isinc,float *p){
	int i=blockIdx.x*blockDim.x+threadIdx.x;
        p[srcgeom_gpu0[i]]+=dir_gpu*(
        sinc_s_table[isinc*nsinc_gpu]*source_gpu0[ntrace_gpu*i+it]+
        sinc_s_table[isinc*nsinc_gpu+1]*source_gpu0[ntrace_gpu*i+it+1]+
	sinc_s_table[isinc*nsinc_gpu+2]*source_gpu0[ntrace_gpu*i+it+2]+
        sinc_s_table[isinc*nsinc_gpu+3]*source_gpu0[ntrace_gpu*i+it+3]+
	sinc_s_table[isinc*nsinc_gpu+4]*source_gpu0[ntrace_gpu*i+it+4]+
        sinc_s_table[isinc*nsinc_gpu+5]*source_gpu0[ntrace_gpu*i+it+5]+
        sinc_s_table[isinc*nsinc_gpu+6]*source_gpu0[ntrace_gpu*i+it+6]+
        sinc_s_table[isinc*nsinc_gpu+7]*source_gpu0[ntrace_gpu*i+it+7]);


}
extern "C" __global__ void new_data_inject_kernel(int it, int isinc,float *p){
	int j=blockIdx.y*blockDim.y+threadIdx.y;
	int k=blockIdx.x*blockDim.x+threadIdx.x;
	int i=k+n2gpu*j;
	if(i< nrec_gpu){
	    p[datageom_gpu0[i]]+=
            sinc_d_table[isinc*nsinc_gpu]*data_gpu0[ntrace_gpu*i+it] +
	    sinc_d_table[isinc*nsinc_gpu+1]*data_gpu0[ntrace_gpu*i+it+1]+
	    sinc_d_table[isinc*nsinc_gpu+2]*data_gpu0[ntrace_gpu*i+it+2]+
	    sinc_d_table[isinc*nsinc_gpu+3]*data_gpu0[ntrace_gpu*i+it+3]+
	    sinc_d_table[isinc*nsinc_gpu+4]*data_gpu0[ntrace_gpu*i+it+4]+
	    sinc_d_table[isinc*nsinc_gpu+5]*data_gpu0[ntrace_gpu*i+it+5]+
	    sinc_d_table[isinc*nsinc_gpu+6]*data_gpu0[ntrace_gpu*i+it+6]+
	    sinc_d_table[isinc*nsinc_gpu+7]*data_gpu0[ntrace_gpu*i+it+7];
	}

}

extern "C" __global__ void new_data_extract_kernel(int it, int isinc,float *p){
	int j=blockIdx.y*blockDim.y+threadIdx.y;
	int k=blockIdx.x*blockDim.x+threadIdx.x;
	int i=k+n2gpu*j;
	if(i< nrec_gpu){
	  data_gpu0[ntrace_gpu*i+it+0]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+0];
	  data_gpu0[ntrace_gpu*i+it+1]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+1];
	  data_gpu0[ntrace_gpu*i+it+2]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+2];
	  data_gpu0[ntrace_gpu*i+it+3]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+3];
	  data_gpu0[ntrace_gpu*i+it+4]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+4];
	  data_gpu0[ntrace_gpu*i+it+5]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+5];
	  data_gpu0[ntrace_gpu*i+it+6]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+6];
	  data_gpu0[ntrace_gpu*i+it+7]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+7];
  }
}
 
extern "C" __global__ void img_kernel( float* img, float*dat, float*src){/*ok. now this is just pure guesswork!*/
	int nblocksz=(n1gpu-2*FAT)/BLOCKZ_SIZE;
	int yblock=(blockIdx.x/nblocksz);
	int y0=FAT+yblock*BLOCKY_SIZE;
	int il=FAT+threadIdx.x; 				// thread-local z coordinate
	int jl=FAT+threadIdx.y;					// thread-local x coordinate
	int ig=(blockIdx.x-yblock*nblocksz)*blockDim.x+il; 	// global z coordinates
	int jg=blockIdx.y*blockDim.y+jl; 	 		// global x coordinates

	for(int yy=0; yy<BLOCKY_SIZE; yy++){
          img[dloc(ig,jg,y0+yy)]+=.000001*dat[dloc(ig,jg,y0+yy)]*src[dloc(ig,jg,y0+yy)];
	}
}

extern "C" __global__ void slice_kernel(int nblocks, float *p, float *s, int depth)
{
	int yblock=(blockIdx.x/nblocks);
	int y0=yblock*BLOCKY_SIZE;
	int xl=FAT+threadIdx.y; 		// local  xdir
	int xg=blockIdx.y*blockDim.y+xl; 	// global xdir

	for(int yy=0; yy<BLOCKY_SIZE; yy++){
	  s[dloc2(xg,y0+yy)]=p[dloc(depth,xg,y0+yy)];
	}
}

extern "C" __global__ void img_add_kernel( float* img, float*rec_field, float *src_field){//as above, added 
	int nblocksz=(n1gpu-2*FAT)/BLOCKZ_SIZE;
	int yblock=(blockIdx.x/nblocksz);
	int y0=FAT+yblock*BLOCKY_SIZE;
	int il=FAT+threadIdx.x; 				// thread-local z coordinate
	int jl=FAT+threadIdx.y;					// thread-local x coordinate
	int ig=(blockIdx.x-yblock*nblocksz)*blockDim.x+il; 	// global z coordinates
	int jg=blockIdx.y*blockDim.y+jl; 	 		// global x coordinates

	for(int yy=0; yy<BLOCKY_SIZE; yy++){
          rec_field[dloc(ig,jg,y0+yy)]+=.000001*src_field[dloc(ig,jg,y0+yy)]*img[dloc(ig,jg,y0+yy)];
	}
}

void setup_cuda(int device, int argc, char **argv){
  cudaSetDevice(device);
  cudaDeviceProp properties;
  cudaGetDeviceProperties(&properties,device);
  fprintf(stderr,"Using single GPU %s (%d)\n", properties.name, device);
}

void source_prop(int n1, int n2, int n3, bool damp, bool get_last, float *p0, float *p1, float *tmp, int jt,
int npts,int nt,int nextract, int *extract_pts, float *extracted,int jwave, char *tag){

  //Propagate the source wavefield and return the final two 3D wavefield slices
  float *ptemp;
  float *p0_gpu,*p1_gpu, *s_gpu;
  cuda_call(cudaMalloc((void**) &p0_gpu,n1*n2*n3*sizeof(float)));
  cuda_call(cudaMalloc((void**) &p1_gpu,n1*n2*n3*sizeof(float)));
  cuda_call(cudaMalloc((void**) &s_gpu,n2*n3*sizeof(float)));

  //ZERO GPU MEMORY
  cuda_call(cudaMemset(p0_gpu, 0,n1*n2*n3*sizeof(float)));
  cuda_call(cudaMemset(p1_gpu, 0,n1*n2*n3*sizeof(float)));
  cuda_call(cudaMemset(s_gpu,  0, n2*n3*sizeof(float)));

  //SET SOURCE PROP DIRECTION
  int dir=1;
  cuda_call(cudaMemcpyToSymbol(dir_gpu, &dir, sizeof(float)));

  //GPU BLOCKS
  int nblocksz=(n1-2*FAT)/BLOCKZ_SIZE;
  int nblocksx=(n2-2*FAT)/BLOCKX_SIZE; /* remainder points will be ignored */
  int nblocksy=(n3-2*FAT)/BLOCKY_SIZE; /* remainder points will be ignored */
  dim3 dimGrid(nblocksz*nblocksy,nblocksx);
  dim3 dimBlock(BLOCKZ_SIZE, BLOCKX_SIZE);

  for(int it=0; it<=nt; it++){
    //POINTERS INTO DATA ARRAY AND SINC ARRAY
    int id=it/jt;
    int i=it-id*jt;

    //FORWARD PROPAGATE SOURCE
    kernel_exec(wave_kernel<<<dimGrid, dimBlock>>>(p0_gpu, p1_gpu, p0_gpu));
    kernel_exec(new_src_inject_kernel<<<1,npts>>>(id /*size of sinc*/,i, p0_gpu));

    ptemp=p0_gpu; p0_gpu=p1_gpu;p1_gpu=ptemp;
  }

  if(get_last){
    cuda_call(cudaMemcpy(p0, p0_gpu, n1*n2*n3*sizeof(float), cudaMemcpyDeviceToHost));
    cuda_call(cudaMemcpy(p1, p1_gpu, n1*n2*n3*sizeof(float), cudaMemcpyDeviceToHost));
  }

  //FREE GPU MEMORY ALL OPTIONS
  cuda_call( cudaFree(source_gpu) );
  cuda_call( cudaFree(srcgeom_gpu));
  cuda_call( cudaFree(p0_gpu));
  cuda_call( cudaFree(p1_gpu));
  cuda_call( cudaFree(s_gpu));
}

void rtm_forward(int n1, int n2, int n3, int jt, float *img, float *dat, int npts_src, int npts,
int nt,int nt_big, int nrec){

  //Born modelling over input image
  //ALLOCATE GPU SPACE
  float *src_p0,*src_p1,*data_p0,*data_p1,*img_gpu;
  cuda_call(cudaMalloc((void**) &src_p0, n1*n2*n3*sizeof(float)));
  cuda_call(cudaMalloc((void**) &src_p1, n1*n2*n3*sizeof(float)));
  cuda_call(cudaMalloc((void**) &data_p0, n1*n2*n3*sizeof(float)));
  cuda_call(cudaMalloc((void**) &data_p1, n1*n2*n3*sizeof(float))); 
  cuda_call(cudaMalloc((void**) &img_gpu, n1*n2*n3*sizeof(float)));

  //INITIALIZE GPU MEMORY
  cuda_call(cudaMemset(data_p0, 0,n1*n2*n3*sizeof(float)));
  cuda_call(cudaMemset(data_p1, 0,n1*n2*n3*sizeof(float)));
  cuda_call(cudaMemset(src_p0, 0,n1*n2*n3*sizeof(float)));
  cuda_call(cudaMemset(src_p1, 0,n1*n2*n3*sizeof(float))); 
  cuda_call(cudaMemset(data_gpu, 0,nt_big*nrec*sizeof(float))); 
  cuda_call(cudaMemcpy(img_gpu, img, n1*n2*n3*sizeof(float), cudaMemcpyHostToDevice));

  //SET SOURCE PROPAGATION DIRECTION
  int dir=1;
  cuda_call(cudaMemcpyToSymbol(dir_gpu, &dir, sizeof(float)));

  //SET GPU GRID DIMENSIONS
  int nblocksz=(n1-2*FAT)/BLOCKZ_SIZE; /* remainder points will be ignored */
  int nblocksx=(n2-2*FAT)/BLOCKX_SIZE; /* remainder points will be ignored */
  int nblocksy=(n3-2*FAT)/BLOCKY_SIZE; /* remainder points will be ignored */

  dim3 dimGrid(nblocksz*nblocksy,nblocksx);
  dim3 dimBlock(BLOCKZ_SIZE, BLOCKX_SIZE);
  dim3 dimGridx((int)ceilf(1.*n2/BLOCKX_SIZE),(int)ceilf(1.*n3/BLOCKY_SIZE));
  dim3 dimBlockx(BLOCKX_SIZE, BLOCKY_SIZE);

  for(int it=0; it < nt; it++){

    //Pointer into data array and sync positon
    int id=it/jt;
    int i=it-id*jt;
    //Propagate data (adjoint rather than inverse)
    kernel_exec(damp_kernel<<<dimGrid, dimBlock>>>(nblocksz,data_p0, data_p1));
    kernel_exec(wave_kernel_adj2<<<dimGrid, dimBlock>>>(data_p0,data_p1,data_p0));
 
    //Propagate source forward 
    kernel_exec(wave_kernel<<<dimGrid, dimBlock>>>(src_p0,src_p1,src_p0));
    //Damping the source wavefield causes the dot product to be a long way off, so it is not done

    //Inject source 
    kernel_exec(new_src_inject_kernel<<<1,npts_src>>>(id /*size of sinc*/,i, src_p0));

    if(it%jt==0) kernel_exec(img_add_kernel<<<dimGrid, dimBlock>>>(img_gpu,data_p0,src_p0));

    //Extract data
    kernel_exec(new_data_extract_kernel<<<dimGridx, dimBlockx>>>(id ,i, data_p0));

    float *ptemp2=src_p1; src_p1=src_p0; src_p0=ptemp2;
    float *ptemp=data_p1; data_p1=data_p0; data_p0=ptemp;
  }

  //Copy gpu version of data back to CPU
  cuda_call(cudaMemcpy(dat, data_gpu, nt_big*nrec*sizeof(float), cudaMemcpyDeviceToHost));

  cuda_call( cudaFree(datageom_gpu));
  cuda_call( cudaFree(data_p0));
  cuda_call( cudaFree(data_gpu));
  cuda_call( cudaFree(img_gpu) );
  cuda_call( cudaFree(source_gpu) );
  cuda_call( cudaFree(srcgeom_gpu));
  cuda_call( cudaFree(data_p1));
  cuda_call( cudaFree(src_p0));
  cuda_call( cudaFree(src_p1));
}



void rtm_adjoint(int n1, int n2, int n3, int jt, float *p0_s_cpu, float *p1_s_cpu, float *img, float *tmp2, int npts_src, int npts,int nt){
   float *src_p0,*src_p1,*data_p0,*data_p1,*img_gpu,*ptemp;
   //RTM, return image

   cuda_call(cudaMalloc((void**) &src_p0, n1*n2*n3*sizeof(float)));
   cuda_call(cudaMalloc((void**) &src_p1, n1*n2*n3*sizeof(float)));
   cuda_call(cudaMalloc((void**) &data_p0, n1*n2*n3*sizeof(float)));
   cuda_call(cudaMalloc((void**) &data_p1, n1*n2*n3*sizeof(float))); 
   cuda_call(cudaMalloc((void**) &img_gpu, n1*n2*n3*sizeof(float)));

   //ZERO BUFFERS
   cuda_call(cudaMemset(data_p0, 0,n1*n2*n3*sizeof(float)));
   cuda_call(cudaMemset(data_p1, 0,n1*n2*n3*sizeof(float)));
   cuda_call(cudaMemset(img_gpu, 0,n1*n2*n3*sizeof(float)));

   //COPY SOURCE BUFFER FOR REVERSE PROPAGATION
   cuda_call(cudaMemcpy(src_p0, p0_s_cpu, n1*n2*n3*sizeof(float), cudaMemcpyHostToDevice));
   cuda_call(cudaMemcpy(src_p1, p1_s_cpu, n1*n2*n3*sizeof(float), cudaMemcpyHostToDevice));

   //BLOCKS FOR THE GPU
   int nblocksz=(n1-2*FAT)/BLOCKZ_SIZE;
   int nblocksx=(n2-2*FAT)/BLOCKX_SIZE; /* remainder points will be ignored */
   int nblocksy=(n3-2*FAT)/BLOCKY_SIZE; /* remainder points will be ignored */

   dim3 dimGrid(nblocksz*nblocksy,nblocksx);
   dim3 dimBlock(BLOCKZ_SIZE, BLOCKX_SIZE);
   dim3 dimGridx((int)ceilf(1.*n2/BLOCKX_SIZE),(int)ceilf(1.*n3/BLOCKY_SIZE));
   dim3 dimBlockx(BLOCKX_SIZE, BLOCKY_SIZE);

   //IMAGING VS PROPAGATION STEPS FOR SOURCE SUBTRACT
   int dir=-1;
   cuda_call(cudaMemcpyToSymbol(dir_gpu, &dir, sizeof(float)));

   int id_s=(nt+1)/jt;
   int i_s=nt+1-id_s*jt;
   kernel_exec(new_src_inject_kernel<<<1,npts_src>>>(id_s,i_s,src_p0));

   for(int it=nt-1; it >=0 ;it--){

     id_s=(it+1)/jt;//SAMPLING INTO SOURCE FIELD
     i_s=it+1-id_s*jt;//OFFSET FROM SOURCE FIELD
     int id=it/jt;  //POINTER INTO DATA SAMPLING
     int i=it-id*jt;//OFFSET FROM DATA SAMPLING
     //REVERSE PROPAGATE DATA
     kernel_exec(wave_kernel2<<<dimGrid, dimBlock>>>(data_p0,data_p1,data_p0));
     kernel_exec(damp_kernel<<<dimGrid, dimBlock>>>(nblocksz,data_p0,data_p1));

     if(it<nt-1){
       kernel_exec(wave_kernel<<<dimGrid, dimBlock>>>(src_p0, src_p1, src_p0));
       kernel_exec(new_src_inject_kernel<<<1,npts_src>>>(id_s /*size of sinc*/,i_s, src_p1));
     }

    //INJECT DATA AT CURRENT TIME SAMPLE
    kernel_exec(new_data_inject_kernel<<<dimGridx, dimBlockx>>>(id ,i, data_p0));

    if(i==0) kernel_exec(img_kernel<<<dimGrid, dimBlock>>>(img_gpu,data_p0,src_p0));

    if(it<nt-1){ ptemp=src_p0; src_p0=src_p1;src_p1=ptemp;}

    float *ptemp2=data_p1; data_p1=data_p0; data_p0=ptemp2;
   }

  cuda_call(cudaMemcpy(img, img_gpu, n1*n2*n3*sizeof(float), cudaMemcpyDeviceToHost));

  //FREE GPU MEMORY
  cuda_call( cudaFree(datageom_gpu));
  cuda_call( cudaFree(data_p0));
  cuda_call( cudaFree(data_gpu));
  cuda_call( cudaFree(img_gpu) );
  cuda_call( cudaFree(source_gpu0) );
  cuda_call( cudaFree(srcgeom_gpu0));
  cuda_call( cudaFree(data_p1));
  cuda_call( cudaFree(src_p0));
  cuda_call( cudaFree(src_p1));
}

void transfer_sinc_table_s(int nsinc, int ns,  float **tables){
   float *tmp_table1=(float*)malloc(sizeof(float)*nsinc*ns);
   for(int i=0; i < ns; i++) memcpy((tmp_table1+nsinc*i),tables[i],nsinc*sizeof(float));
   cuda_call(cudaMalloc((void**) &sincstable,ns*nsinc*sizeof(float)));
   cuda_call(cudaMemcpy(sincstable, tmp_table1, ns*nsinc*sizeof(float),cudaMemcpyHostToDevice));
   cuda_call(cudaMemcpyToSymbol(sinc_s_table, &sincstable, sizeof(float*)));
   free(tmp_table1);
   cuda_call(cudaMemcpyToSymbol(nsinc_gpu, &nsinc, sizeof(int)));
 }

void transfer_sinc_table_d(int nsinc,  int nd, float **tabled){
   float *tmp_table2=(float*)malloc(sizeof(float)*nsinc*nd);
   for(int i=0; i < nd; i++) memcpy((tmp_table2+nsinc*i),tabled[i],nsinc*sizeof(float));
   cuda_call(cudaMalloc((void**) &sincdtable,nd*nsinc*sizeof(float)));
   cuda_call(cudaMemcpy(sincdtable, tmp_table2, nd*nsinc*sizeof(float),cudaMemcpyHostToDevice));
   cuda_call(cudaMemcpyToSymbol(sinc_d_table, &sincdtable, sizeof(float*)));
   free(tmp_table2);
}

void transfer_source_func(int npts, int nt, int *locs, float *vals){
  cuda_call(cudaMalloc((void**) &source_gpu,nt*npts*sizeof(float)));
  cuda_call(cudaMalloc((void**) &srcgeom_gpu,npts*sizeof(float)));
  cuda_call(cudaMemcpy(srcgeom_gpu, locs, npts*sizeof(float), cudaMemcpyHostToDevice));
  cuda_call(cudaMemcpy(source_gpu, vals, nt*npts*sizeof(float), cudaMemcpyHostToDevice));
  cuda_call(cudaMemcpyToSymbol(ntrace_gpu, &nt, sizeof(int)));
  cuda_call(cudaMemcpyToSymbol(srcgeom_gpu0, &srcgeom_gpu, sizeof(float*)));
  cuda_call(cudaMemcpyToSymbol(source_gpu0, &source_gpu, sizeof(float*)));
}

void transfer_receiver_func(int npts, int nt, int *locs, float *vals){
  cuda_call(cudaMalloc((void**) &data_gpu,nt*npts*sizeof(float)));
  cuda_call(cudaMalloc((void**) &datageom_gpu,npts*sizeof(float)));
  cuda_call(cudaMemcpy(datageom_gpu, locs, npts*sizeof(float),	 cudaMemcpyHostToDevice));
  cuda_call(cudaMemcpy(data_gpu, vals, nt*npts*sizeof(float), cudaMemcpyHostToDevice));
  cuda_call(cudaMemcpyToSymbol(nrec_gpu, &npts, sizeof(int)));
  cuda_call(cudaMemcpyToSymbol(ntrace_gpu, &nt, sizeof(int)));
  cuda_call(cudaMemcpyToSymbol(datageom_gpu0, &datageom_gpu, sizeof(int)));
  cuda_call(cudaMemcpyToSymbol(data_gpu0, &data_gpu, sizeof(int)));
}

extern "C" __global__ void readTexels(int n, float *check_tex_d){
	int i=blockIdx.x*blockDim.x+threadIdx.x;
	if(i<n){
	  float x = tex3D(vel_ref1,i,1,1);
	  check_tex_d[i] = i;
	}
}

void transfer_vel_func1(int nz, int nx, int ny, float *vel){
    //These routines define the velocity as 3D textures
    cudaExtent const extv1 = {nz, nx, ny};
    cudaMemcpy3DParms cp1 = {0};

    cp1.srcPtr = make_cudaPitchedPtr((void*)vel, nz*sizeof(float), nz, nx);
    cp1.dstArray = vel_array1;
    cp1.extent = extv1;
    cp1.kind = cudaMemcpyHostToDevice;
    cuda_call( cudaMemcpy3D(&cp1));

//    vel_ref1.filterMode=cudaFilterModeLinear
    vel_ref1.addressMode[0]=cudaAddressModeClamp;
    vel_ref1.addressMode[1]=cudaAddressModeClamp;
    vel_ref1.addressMode[2]=cudaAddressModeClamp;

    cuda_call(cudaBindTextureToArray(vel_ref1, vel_array1));
}

void transfer_vel_func2(int nz, int nx, int ny, float *vel){
    //These routines define the velocity as 3D textures
    cudaExtent const extv2 = {nz, nx, ny};
    cudaMemcpy3DParms cp2 = {0};

    cp2.srcPtr = make_cudaPitchedPtr((void*)vel, nz*sizeof(float), nz, nx);
    cp2.dstArray = vel_array2;
    cp2.extent = extv2;
    cp2.kind = cudaMemcpyHostToDevice;
    cuda_call( cudaMemcpy3D(&cp2));

//    vel_ref2.filterMode=cudaFilterModeLinear
    vel_ref2.addressMode[0]=cudaAddressModeClamp;
    vel_ref2.addressMode[1]=cudaAddressModeClamp;
    vel_ref2.addressMode[2]=cudaAddressModeClamp;

    cuda_call(cudaBindTextureToArray(vel_ref2, vel_array2));
} 

void create_gpu_space(float d1, float d2, float d3, float bc_a, float bc_b, float bc_b_y, int nz, int nx, int ny){
    //Here we set up the invariants of our GPU domain
    int n1=nz;
    int n2=nx;
    int n3=ny;

    cudaChannelFormatDesc cf1 = cudaCreateChannelDesc<float>();
    cudaExtent const extv1 = {n1, n2, n3};
    cuda_call(cudaMalloc3DArray(&vel_array1, &cf1, extv1));

    cudaChannelFormatDesc cf2 = cudaCreateChannelDesc<float>();
    cudaExtent const extv2 = {n1, n2, n3};
    cuda_call(cudaMalloc3DArray(&vel_array2, &cf2, extv2));

    cuda_call(cudaMemcpyToSymbol(n1gpu, &n1, sizeof(int)));
    cuda_call(cudaMemcpyToSymbol(n2gpu, &n2, sizeof(int)));
    cuda_call(cudaMemcpyToSymbol(n3gpu, &n3, sizeof(int)));
    cuda_call(cudaMemcpyToSymbol(bc_agpu, &bc_a, sizeof(float)));
    cuda_call(cudaMemcpyToSymbol(bc_bgpu, &bc_b, sizeof(float)));
    cuda_call(cudaMemcpyToSymbol(bc_b_ygpu, &bc_b_y, sizeof(float)));

    float coeffs_cpu[COEFFS_SIZE]=get_coeffs((double)d1,(double)d2,(double)d3);
    dd1=1./(double)d1/(double)d1;
    dd2=1./(double)d2/(double)d2;
    dd3=1./(double)d3/(double)d3;

    cuda_call(cudaMemcpyToSymbol(coeffs, coeffs_cpu, COEFFS_SIZE*sizeof(float), 0,cudaMemcpyHostToDevice));
}

