#include "image_off_3d.h"
#include "float_3d.h"

image_off::image_off(hypercube_float *model,hypercube_float *source,axis at){

  *s=(float_3d*) source;
  nhx=model->get_axis(4).n;
  nhy=model->get_axis(4).n;

  nt=at.n;
  dt=at.d;

}

bool image_off::adjoint(bool add, my_vector *model, my_vector *data,int iter){
  hypercube_float *r=(float_3d*) data;
  hypercube_float *i=(float_3d*) model;

//  axis at=d->get_axis(1);
  axis az=r->get_axis(1);
  axis ax=r->get_axis(2);
  axis ay=r->get_axis(3);

  if(!add){ s->zero(); r->zero();}
  hx=0;hy=0;

//  for(int it=0; it<((nt+1)/jtd); it++){
   for(int iy=0; iy<ay.n; iy++){
    for(int ix=0; ix<ax.n; ix++){
     for(int iz=0; iz<az.n; iz++){
      for(int ihx=0; ihx<nhx-1; ihx++){
       hx=ihx-nhx/2;
       for(int ihy=0; ihy<nhy-1; ihy++){
        hy=ihy-nhy/2;
       }
      }
     }
    }
   }
//  }


}

bool image_off::forward(bool add, my_vector *model, my_vector *data,int iter){
  hypercube_float *r=(float_3d*) data;
  hypercube_float *i=(float_3d*) model;

//  axis at=d->get_axis(1);
  axis az=r->get_axis(1);
  axis ax=r->get_axis(2);
  axis ay=r->get_axis(3);

  if(!add) i->zero();
  hx=0;hy=0;
  int it=0;
//  for(int it=0; it<((nt+1)/jtd); it++){
   for(int iy=0; iy<ay.n; iy++){
    for(int ix=0; ix<ax.n; ix++){
     for(int iz=0; iz<az.n; iz++){
      for(int ihx=0; ihx<nhx-1; ihx++){
       hx=ihx-nhx/2;

       if(ix > nhx/2 && ix < (ax.n-nhx/2)){
        i->vals[iz+ix*az.n+iy*az.n*ax.n+ihx*az.n*ax.n*ay.n] += r->vals[iz+(ix-hx)*az.n+it*az.n*ax.n*ay.n]*s->vals[iz+(ix+hx)*az.n+it*az.n*ax.n];
       }
       else{
        i->vals[iz+ix*az.n+iy*az.n*ax.n+ihx*az.n*ax.n*ay.n] += r->vals[iz+(ix)*az.n+it*az.n*ax.n*ay.n]*s->vals[iz+(ix)*az.n+it*az.n*ax.n];
       }

       for(int ihy=0; ihy<nhy-1; ihy++){
        hy=ihy-nhy/2;

	if(iy > nhy/2 && iy < (ay.n-nhy/2)){
         i->vals[iz+ix*az.n+iy*az.n*ax.n+ihx*az.n*ax.n*ay.n+ihy*az.n*ax.n*ay.n*nhx] += r->vals[iz+(ix)*az.n+(iy-hy)*az.n*ax.n+it*az.n*ax.n*ay.n]*s->vals[iz+(ix)*az.n+(iy+hy)*az.n*ax.n+it*az.n*ax.n*ay.n];
	}
	else{
         i->vals[iz+ix*az.n+iy*az.n*ax.n+ihx*az.n*ax.n*ay.n+ihy*az.n*ax.n*ay.n*nhx] += r->vals[iz+(ix)*az.n+(iy)*az.n*ax.n+it*az.n*ax.n*ay.n]*s->vals[iz+(ix)*az.n+(iy)*az.n*ax.n+it*az.n*ax.n*ay.n];

        }
       }
      }
     }
    }
   }
 // }

}
